---
layout: post
title: MvvmCross 4.1
date:   2016-03-22 11:37:35 +0100
categories: mvvmcross
---
As some of you might have discovered, new NuGet packages with the version number 4.1.0 are beginning to pop up.

##  iOS Support Repository

The new iOS Support repo aims to make your life easier by providing all kind of standard classes and helpers for iOS.

In the initial version we added:
- ViewExtensions
- MvxBaseViewController
- MvxExpandableTableViewSource
- JASidePanels

Let us know if you have idea's for this by adding an issue to the [repo](https://github.com/MvvmCross/MvvmCross-iOSSupport) or submit a pull request.

##  Main Repository

- Improved NotifyDataSetException messages
- Added MvxCollectionReusableView for binding of UICollectionReusableView on iOS
- Fix for Replace Animations for TableView on iOS
- Added helpers for localization with fluent bindings
- Fixed MvxWindowsMultiRegionViewPresenter not searching for nested frames
- Added missing JNI interop constructors for several classes
- Improvements to how Bitmaps are handled in MvxImageView and MvxImageViewHelper
- Added Swipe Gestures for iOS
- Added Value target binding for UIStepper
- Added ValueChange command binding for UIControl (UIStepper, UISlider and many more)
- Loads of additions to Analyzers

## Plugins

- Renamed *deleteExisitingTo* to *overwrite* in File plugin
- Added TryCopy method for non-Windows platforms
- Not eating useful exceptions on Windows in File plugin
- Added RESX Localization plugin
- Added OpenFlags to SQLiteConfig in SQLite-PCL plugin
- Added Bindings as dependency for MethodBindings and FieldBindings nuspec
- Improved concurrency in MvxImageCache
- Updated Android.Support packages to 23.1.1.1

## AndroidSupport

- Lowercased namespaces in all `[Register]` attributes for better ProGuard support
- Added more extension points by making methods virtual in classes
- Fix issue with backstack in CachingFragmentCompatActivity (CFCA)
- Fix issue with rotation in CFCA
- Updated Android.Support packages to 23.1.1.1
- Added FloatingActionButton Scroll behavior
- Added Backstack property for FragmentAttribute to allow fragment being put onto back stack

## All Repositories

We added a new issue template for all MvvmCross repositories, which better explains what we expect people to provide when filing issues.

A huge thanks to all the contributors for this release. It is really nice seeing so many people helping out where they can. Either by opening issues or chipping in with ideas or even better making pull requests. All your help is really appreciated!

// Cheesebaron